local assets=
{
	Asset("ANIM", "anim/rose_amulet.zip"),
	Asset("ANIM", "anim/torso_rose_amulet.zip"),
	Asset("IMAGE", "images/inventoryimages/rose_amulet.tex"),
    Asset("ATLAS", "images/inventoryimages/rose_amulet.xml"),
}


local chinseshunger = {

"我饿了，我需要食物！",

"如果你还不给我食物，我会让你死得很惨的！",

"铲屎的！我饿了！",

"我的饱食度太低了，这对你来说不是一件好事！",

"你想做我的食物吗？快去拿些来！",

"你忘了，我只吃活的生物！",

"如果你再不管我我就把你偷看别人洗澡的事情说出去！",


}

local engilshhunger = {

"I'm hungry. I need food! ",

"If you don't give me food, I'll make you die! ",

"S**t! I am hungry! ",

"My hunger was too low. It's not good for you! ",

"Do you want to be my food? Go and get some! ",

"You forget, I only eat living creatures! ",

"If you don't care about me anymore, I'll tell others about you peeping at other people's baths! ",


}

local chinses = {

"我觉得我们可以谈谈！",

"你让我吃得很愉快！",

"我不再饿了这是一件好事！",

"我想我们可以相处的很愉快！",

"你放心我不饿的时候不吃人！",

"伙计做坏事别忘了带上我！",


}


local engilsh = {

"I think we can talk about it! ",

"You made me have a good time! ",

"I'm not hungry anymore. That's good! ",

"I think we have a good time together! ",

"Don't worry that I won't eat human when I'm not hungry! ",

"Don't forget to take me with you when you are doing something bad, guy! ",

}


local chinsesht = {

"啊！",

"额！",

"哦！",

"给我挠挠痒！",

"再重一点！",

"我感觉不到疼痛！",

}

local engilshht = {

"Ahhhh！",

"Ohhhh！",

"Emmmm！",

"You are too weak! ",

"More! ",

"I don't feel pain! ",

}

local chinseseht = {

"你别这样看着我，我饿了！",

"我帮不了你！",

"你只能靠你自己了，傻瓜！",

"这就是你没有喂饱我的代价！",

"铲屎的要死了，哈哈！",

"去找一只活物或许我可以帮助你！",

}

local engilsheht = {

"Don't look at me like that. I'm hungry! ",

"I can't help you! ",

"You have to do somthing by yourself, fool! ",

"That's the price you didn't feed me! ",

"You will die, haha! ",

"Find a living creatures, maybe I can help you! ",

}


local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_body", "torso_rose_amulet", "yellowamulet")
	inst.testfn(inst)
    if inst.components.rosecharge.charge > 0 then	
	   if IS_CHINESE_LANGUAGE then
	       inst.components.talker:Say("我来让你见识下真正的力量！", 5, false)
	   else
           inst.components.talker:Say("Let me show you the real power！", 5, false)
	   end
	
	end
	inst.OnBlocked = function()
	  if inst.components.rosecharge.charge > 0 then	
	     owner:AddChild(SpawnPrefab("vortex_cloak_fx")) 
   	     owner.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/vortex_armour/equip_on")	
         if IS_CHINESE_LANGUAGE then
	          inst.components.talker:Say(chinsesht[math.random(1,6)], 1, false)
	     else
              inst.components.talker:Say(engilshht[math.random(1,6)], 1, false)
	     end
	else
         if IS_CHINESE_LANGUAGE then
	          inst.components.talker:Say(chinseseht[math.random(1,6)], 2, false)
	     else
              inst.components.talker:Say(engilsheht[math.random(1,6)], 2, false)
	     end
		
	  end
	
	end


	inst:ListenForEvent("attacked", inst.OnBlocked,owner)     
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
	
	if owner:HasTag("eyeofrose") or owner:HasTag("NOVACUUM") or owner:HasTag("not_hit_stunned") then
       owner:RemoveTag("eyeofrose")
	   owner:RemoveTag("NOVACUUM")
	   owner:RemoveTag("not_hit_stunned")	
	end

	inst:RemoveEventCallback("attacked", inst.OnBlocked,owner)
	if owner.HUD then
       owner.HUD.bloodover:UpdateState()	
	end
end

local function OnGetItemFromPlayer(inst, giver, item)

 if item:HasTag("pet") then

    inst.components.rosecharge:Use(giver)
	inst.SoundEmitter:PlaySound("dontstarve/wilson/eat","eating")	
    if  inst.SoundEmitter:PlayingSound("eating") then
	
	    inst:DoTaskInTime(70*FRAMES,function() 
		   inst.SoundEmitter:KillSound("eating")
	
	    end)		
	end

 end


end

local function ShouldAcceptItem(inst,item)

print("ShouldAcceptItem")

return item:HasTag("pet") 

end


local function fn(inst)
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	MakeInventoryPhysics(inst)   		

	inst.AnimState:SetBank("rose_amulet")
	inst.AnimState:SetBuild("rose_amulet")
	inst.AnimState:PlayAnimation("idle",true)
    MakeInventoryFloatable(inst, "idle_water", "idle")

	inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )	

	
	inst:AddComponent("inspectable")	
	
	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.BODY
	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/jewlery"

	
	inst.components.inventoryitem.atlasname = "images/inventoryimages/rose_amulet.xml"
    inst.components.inventoryitem.imagename = "rose_amulet"

	
	inst:AddComponent("rosecharge")
    inst.components.rosecharge.cooldowntime =  TUNING.TOTAL_DAY_TIME
	inst.components.rosecharge.value = 5
	inst.components.rosecharge.maxcharge = 60
	
	inst:AddComponent("trader")
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader:SetAcceptTest(ShouldAcceptItem)
	
	
	inst:AddComponent("talker")

    inst.components.talker.fontsize = 28
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(.9, .4, .4, 1)
    inst.components.talker.offset = Vector3(0,0,0)
    inst.components.talker.symbol = "swap_body"
		
	inst.testfn = function(inst) 
	
      local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
	
	  if inst.components.equippable:IsEquipped() and inst.components.rosecharge then
	    if inst.components.rosecharge.charge > 0 then		
		   owner:AddTag("eyeofrose")
		   owner:AddTag("NOVACUUM")
		   owner:AddTag("not_hit_stunned")
		   print("Add eyeofrose")
        else
           owner:RemoveTag("eyeofrose")
		   owner:RemoveTag("NOVACUUM")
		   owner:RemoveTag("not_hit_stunned")
		    print("Remove eyeofrose")
			if owner.HUD then
              owner.HUD.bloodover:UpdateState()
            end			  
	    end
	  end
	  
	end
	
	inst.components.equippable:SetOnEquip( onequip )
	inst.components.equippable:SetOnUnequip( onunequip )
	
	inst:ListenForEvent("rose_charge_delta",inst.testfn)
	
    inst:ListenForEvent("equipped",function()
	inst.components.rosecharge.cooldowntime = 1
	
	end)
    inst:ListenForEvent("unequipped",function()
	inst.components.rosecharge.cooldowntime =  TUNING.TOTAL_DAY_TIME
		
	end)
	
	inst:DoPeriodicTask(20, function(inst) 
	  if inst.components.rosecharge and not inst.components.equippable:IsEquipped() then
	     if inst.components.rosecharge.charge < 50 then	
		 
	       if IS_CHINESE_LANGUAGE then
	          inst.components.talker:Say(chinseshunger[math.random(1,7)], 5, false)
	       else
              inst.components.talker:Say(chinseshunger[math.random(1,7)], 5, false)
	       end
		   
		 else
		 
	       if IS_CHINESE_LANGUAGE then
	          inst.components.talker:Say(chinses[math.random(1,6)], 5, false)
	       else
              inst.components.talker:Say(engilsh[math.random(1,6)], 5, false)
	       end

         end		 
     end   
	end)
	
	inst:DoTaskInTime(0, function() 
		
		local key = 0
		for k,v in pairs(Ents) do
			if v.prefab == inst.prefab then
			     key = key+1
				
				if key > 1 then
				  v:Remove()
				end
				
			end
		end
		
	end)

    return inst
end

return Prefab("common/inventory/rose_amulet", fn, assets)
