local assets =
{
	Asset("ANIM", "anim/smart_soup.zip"),
}

local function oneatfn(inst,eater)

	local num = math.random(0,1)
	if num >0.5 and eater:HasTag("player") then	

	  c_give("roe")
	  eater.sg:GoToState("celebrate") 
	  
	else
	
	  return
	  
	end

end


local function fn(Sim)

	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    anim:SetBank("smart_soup")
    anim:SetBuild("smart_soup")
	MakeInventoryPhysics(inst)   
    anim:PlayAnimation("idle") 
    MakeInventoryFloatable(inst, "idle_water", "idle")
	
    inst:AddTag("preparedfood")
	
	inst:AddComponent("inspectable")
	
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "smart_soup"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/smart_soup.xml" 
    inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/jewlery"
	
	inst:AddComponent("edible")
	inst.components.edible.foodtype =  "ROSE"
    inst.components.edible.healthvalue = 10
	inst.components.edible.hungervalue = 60
	inst.components.edible.sanityvalue = 20
    inst.components.edible.surferdelta = TUNING.HYDRO_FOOD_BONUS_SURF
    inst.components.edible.surferduration = TUNING.FOOD_SPEED_LONG*4
    inst.components.edible.autodrydelta = TUNING.HYDRO_FOOD_BONUS_DRY
	inst.components.edible.autodryduration = TUNING.FOOD_SPEED_LONG*4
    inst.components.edible.autocooldelta = TUNING.HYDRO_FOOD_BONUS_COOL_RATE
	
	inst.components.edible.oneaten = oneatfn
	
	inst:AddComponent("perishable")
	inst.components.perishable:SetPerishTime(TUNING.PERISH_SUPERSLOW) 
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"
		
    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM				    
	------------------------------------------------
	inst:AddComponent("tradable")
	------------------------------------------------  
	
    return inst
end

return Prefab( "common/smart_soup", fn, assets) 
